package ly.hall.rose.healthsync;

import com.mojang.authlib.GameProfile;
import net.minecraft.text.Text;

public class PlayerDamageInstance {
    public GameProfile profile;
    public Text damageReason;
    public float health;
    public float lifetime;
    public HeartType heartType;

    PlayerDamageInstance(GameProfile profile, HeartType heartType, Text damageReason, float health) {
        this.profile = profile;
        this.heartType = heartType;
        this.damageReason = damageReason;
        this.health = health;
    }

    public void addTime(float time) {
        this.lifetime += time;
    }

    public void updateHealth(float health) {
        this.health += health;
        this.lifetime = 0;
    }

    public int getHalfHeartCount() {
        return health < 0 ? -((int) Math.ceil(Math.abs(health))) : ((int) Math.ceil(Math.abs(health)));
    }

    public boolean matches(PlayerDamageInstance other) {
        return this.profile.equals(other.profile) && this.damageReason.getString().equals(other.damageReason.getString()) && this.heartType.equals(other.heartType);
    }
}
