package ly.hall.rose.healthsync;

import net.minecraft.entity.LivingEntity;
import java.util.HashSet;
import java.util.Set;

class LivingEntityPostDamageEventHandlerKeyValuePair {
    public LivingEntity entity;
    public LivingEntityPostDamageHandler handler;

    public LivingEntityPostDamageEventHandlerKeyValuePair(LivingEntity e, LivingEntityPostDamageHandler h) {
        this.entity = e;
        this.handler = h;
    }
}

public class LivingEntityPostDamageEvent {
    private static Set<LivingEntityPostDamageEventHandlerKeyValuePair> handlers = new HashSet<LivingEntityPostDamageEventHandlerKeyValuePair>();

    public static void once(LivingEntity e, LivingEntityPostDamageHandler handler) {
        var keyValuePair = new LivingEntityPostDamageEventHandlerKeyValuePair(e, null);

        keyValuePair.handler = () -> {
            handlers.remove(keyValuePair);
            handler.handle();
        };

        handlers.add(keyValuePair);
    }

    public static void emit(LivingEntity e) {
        for (var handler : handlers) {
            if (handler.entity.equals(e)) {
                handler.handler.handle();
            }
        }
    }
}
