package ly.hall.rose.healthsync.mixin.heal;

import ly.hall.rose.healthsync.LivingEntityHealHandler;
import ly.hall.rose.healthsync.LivingEntityHealReason;
import net.minecraft.entity.player.HungerManager;
import net.minecraft.entity.player.PlayerEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(HungerManager.class)
public class HungerManagerMixin {
    @Inject(at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/player/PlayerEntity;heal(F)V", ordinal = 0), method = "update")
    private void handleRegen1(PlayerEntity player, CallbackInfo ci) {
        LivingEntityHealHandler.applyReason(LivingEntityHealReason.NaturalRegeneration);
    }

    @Inject(at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/player/PlayerEntity;heal(F)V", ordinal = 1), method = "update")
    private void handleRegen2(PlayerEntity player, CallbackInfo ci) {
        LivingEntityHealHandler.applyReason(LivingEntityHealReason.NaturalRegeneration);
    }
}
