package ly.hall.rose.healthsync.mixin.heal;

import ly.hall.rose.healthsync.*;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.damage.DamageSource;
import net.minecraft.entity.player.PlayerEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(PlayerEntity.class)
public class PlayerEntityMixin {
    @Inject(at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/player/PlayerEntity;heal(F)V"), method = "tickMovement")
    private void handleRegen(CallbackInfo ci) {
        LivingEntityHealHandler.applyReason(LivingEntityHealReason.NaturalRegeneration);
    }

    @Inject(at = @At(value = "HEAD"), method = "setAbsorptionAmount")
    private void handleAbsorptionUpdate(float targetAbsorption, CallbackInfo ci) {
        var currentAbsorption = ((PlayerEntity)(Object)this).getAbsorptionAmount();
        var difference = targetAbsorption - currentAbsorption;

        if (difference > 0) {
            LivingEntityHealHandler.fire((PlayerEntity)(Object)this, 0, difference);
        }

        if (difference < 0) {
            LivingEntityDamageHandler.fireFromAbsorption((PlayerEntity)(Object)this, difference);
        }
    }
}
