package ly.hall.rose.healthsync.mixin.heal;

import ly.hall.rose.healthsync.LivingEntityHealHandler;
import ly.hall.rose.healthsync.LivingEntityHealReason;
import net.minecraft.nbt.NbtCompound;
import net.minecraft.server.PlayerManager;
import net.minecraft.server.network.ServerPlayerEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import java.util.HashSet;
import java.util.Set;

@Mixin(PlayerManager.class)
public class PlayerManagerMixin {
    @Inject(at = @At("HEAD"), method = "loadPlayerData")
    public void onPlayerDataStart(ServerPlayerEntity player, CallbackInfoReturnable<NbtCompound> cir) {
        LivingEntityHealHandler.loadingPlayers.add(player);
    }

    @Inject(at = @At("RETURN"), method = "loadPlayerData")
    public void onPlayerDataEnd(ServerPlayerEntity player, CallbackInfoReturnable<NbtCompound> cir) {
        LivingEntityHealHandler.loadingPlayers.remove(player);
    }
}
