package ly.hall.rose.healthsync.mixin.heal;

import ly.hall.rose.healthsync.LivingEntityDamageHandler;
import ly.hall.rose.healthsync.LivingEntityHealHandler;
import ly.hall.rose.healthsync.LivingEntityHealReason;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.attribute.*;
import net.minecraft.entity.effect.StatusEffect;
import net.minecraft.entity.effect.StatusEffects;
import net.minecraft.server.network.ServerPlayerEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.Map;

@Mixin(StatusEffect.class)
public class StatusEffectMixin {
    @Inject(at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/LivingEntity;heal(F)V"), method = "applyInstantEffect")
    public void h1(Entity source, Entity attacker, LivingEntity target, int amplifier, double proximity, CallbackInfo ci) {
        if (target instanceof ServerPlayerEntity) {
            LivingEntityHealHandler.applyReason(LivingEntityHealReason.InstantHealthStatusEffect);
        }
    }

    @Inject(at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/LivingEntity;heal(F)V"), method = "applyUpdateEffect")
    public void h1(LivingEntity entity, int amplifier, CallbackInfo ci) {
        if (entity instanceof ServerPlayerEntity) {
            if ((Object) this == StatusEffects.REGENERATION) {
                LivingEntityHealHandler.applyReason(LivingEntityHealReason.RegenerationStatusEffect);
            } else {
                LivingEntityHealHandler.applyReason(LivingEntityHealReason.InstantHealthStatusEffect);
            }
        }
    }
}
